/*
 * Copyright (c) 2008 appspy.org, Contributors.
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 
 * Unless required by applicable law or agreed to in writing, software distributed under the 
 * License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language governing permissions 
 * and limitations under the License. */

package org.appspy.admin.service;

import java.util.Collection;

import org.appspy.server.bo.Dashboard;
import org.appspy.server.bo.Report;
import org.appspy.server.bo.ReportCategory;
import org.appspy.server.bo.ReportParamChooser;
import org.appspy.server.bo.ReportingSystem;



/**
 * @author Olivier HEDIN / olivier@appspy.org
 */
public interface ReportService {
	
	public void deleteReportCategory(ReportCategory cat);
	public ReportCategory createReportCategory(ReportCategory cat);
	public ReportCategory updateReportCategory(ReportCategory cat);
	public Collection<ReportCategory> getReportCategories();
	
	public void deleteReport(Report report);
	public Report createReport(Report report);
	public Report updateReport(Report report);
	public Collection<Report> getReports();
	public Report findReportById(Long reportId);
	
	public void deleteDashboard(Dashboard dashboard);
	public Dashboard createDashboard(Dashboard dashboard);
	public Dashboard updateDashboard(Dashboard dashboard);
	public Collection<Dashboard> getDashboards();
	public Dashboard findDashboardById(Long dashboardId);
	
	public Collection<ReportingSystem> getReportingSystems();
	
	public Collection<ReportParamChooser> getReportParamChoosers();
}
